## -*- coding: utf-8 -*-

"""
Install method

$Id: Install.py 1 2008-03-29 11:30:39Z gael.le-mignot $
"""

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

from Products.Archetypes.public import listTypes, process_types
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

from Products.OnlineExamen.config import *

def addToListProperty(self, out, propertySheet, property, values):
    """Add the given value to the list in the given property
    """
    current = list(propertySheet.getProperty(property))

    for value in values:
        if value not in current:
            current.append(value)
        
    propertySheet.manage_changeProperties(**{property : current})
    out.write("%s added to %s" % (', '.join(values), property))

def install(self):
    """
    Install this product
    """
    out = StringIO()
    portal = getToolByName(self, 'portal_url').getPortalObject()
    print >> out, 'Installing %s' % PROJECT_NAME

    ## Install skin
    install_subskin(self, out, GLOBALS, SKINS_DIR)
    print >> out, 'Installed skin.'

    ## Install types
    types = listTypes(PROJECT_NAME)
    installTypes(self, out, types, PROJECT_NAME)
    print >> out, 'Installed types.'

    ## Enable portal_factory for the new content types
    factory = getToolByName(self, 'portal_factory')
    new_types, useless1, useless2 = process_types(types, PROJECT_NAME)
    types = factory.getFactoryTypes().keys()
    for new_type in new_types:
	if new_type.portal_type not in types:
	    types.append(new_type.portal_type)
    factory.manage_setPortalFactoryTypes(listOfTypeIds=types)
    print >> out, "Added new content types to 'portal_factory'."    

    # Hide types to navigation    
    portalProperties = getToolByName(self, 'portal_properties')
    navtreeProps = getattr(portalProperties, 'navtree_properties')
    siteProps = getattr(portalProperties, 'site_properties')

    addToListProperty(self, out, navtreeProps,
                      'metaTypesNotToList', ("Question",))
    addToListProperty(self, out, siteProps,
                      'types_not_searched', ("Question",))
    addToListProperty(self, out, navtreeProps,
                      'parentMetaTypesNotToQuery', ("Question",))

    print >> out, "Successfully installed %s." % PROJECT_NAME
    return out.getvalue()
