# -*- coding: utf-8 -*-

"""
Product initialization

$Id: __init__.py 1 2008-03-29 11:30:39Z gael.le-mignot $
"""

from Products.CMFCore.utils import ToolInit, ContentInit
from Products.CMFCore.DirectoryView import registerDirectory

from Products.Archetypes.public import process_types, listTypes

from config import GLOBALS, SKINS_DIR, PROJECT_NAME

registerDirectory(SKINS_DIR, GLOBALS)

from content import *


def initialize(context):
    ## Initialize content types
    content_types, constructors, ftis = process_types(
        listTypes(PROJECT_NAME),
        PROJECT_NAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECT_NAME, atype.archetype_name)
        permission = '%s: Add %s' % (PROJECT_NAME,
                                     atype.archetype_name)
        ContentInit(kind,
                    content_types=(atype, ),
                    permission=permission,
                    extra_constructors=(constructor, ),
                    fti=ftis).initialize(context)

